/*********************************************************************

        PIC温湿度計用 ログ保存ソフト for Arduino

本ソースリストおよびソフトウェアは、ライセンスフリーです。
個人での利用は自由に行えます。著作権表示の改変は禁止します。

                               Copyright (c) 2012 Wataru KUNINO
                               http://www.geocities.jp/bokunimowakaru/
*********************************************************************/
/*
参考文献：
・プリント基板で作るPIC応用装置（株式会社ラトルズ）
	鈴木哲哉
・Arduinoをはじめよう (オライリージャパン)
	Massimo Banzi著 船田功訳
・Arduino 日本語リファレンス
	http://www.musashinodenpa.com/arduino/ref/index.php
*/

#include <SD.h>

void setup() {
	Serial.begin(1200);	
	// Serial.begin(9600);	
	Serial.println("hello!");
	while( SD.begin() == false ){
		Serial.println("SD ERROR");
		delay(3000);
	}
}

void loop() {
	byte i;
	byte com[8];	com[7]=0x00;
	File file;
	char filename[] = "hum_com.csv";


	/* COMデータ入力(最大７バイト) */
	Serial.print("waiting for com data... ");
	while( Serial.available() > 1 ){
		while( Serial.read() != 0x0A );		// リターン信号が来るまで空読み
	}
	while( Serial.available() < 6);		// 6バイト以上のデータが貯まるまで待つ
	delay( 4 );							// 約4バイト分の時間待ち
	for( i = 0 ; i < 7 ; i++){
		com[i] = (byte)Serial.read(); // 受信データを読み込む
		if( com[i] == 0x0D || com[i] == 0x0A ){
			com[i] == 0x00;
			break;
		}
	}
	Serial.println( "done" );
	Serial.print("COM DATA = ");
	Serial.write( com , i );
	Serial.print( "\r\n" );

	/* SDへ出力 */
	Serial.print("SD writing... ");
	if( (file = SD.open( filename, FILE_WRITE )) != false ){
		file.write( com , i );
		file.print( "\r\n" );
		file.close();
		Serial.println( "done" );
	} else Serial.println("cannot open file");
	delay(3000);
}

